package JaRPE;

import java.awt.*;
import java.io.*;

public class BorderedPanel extends Panel implements Serializable {

    private String  label;
    private boolean border     = true;
    private Color   labelColor = Color.blue;
    private Font    labelFont  = new Font("Dialog", Font.PLAIN, 10);

    public BorderedPanel() {
        super();
        Dimension dim = getSize();
        setBounds(0, 0 , dim.width + 12, dim.height + 17);
    }

    public BorderedPanel(String label, boolean border) {
        this.label      = label;
        this.border     = border;
        setBackground(SystemColor.control);
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getLabel() {
        return this.label;
    }

    public void setBorder(boolean border) {
        this.border = border;
    }

    public boolean isBorder() {
        return this.border;
    }

    public void paint( Graphics g) {
        Dimension dim = getSize();
        super.paint(g);
        if (border) {
                g.setColor(SystemColor.controlDkShadow);
                g.drawLine(5, dim.height-5, dim.width-5 , dim.height-5);
                g.drawLine(6, 11, dim.width-6 , 11);
                g.drawLine(6, 11, 6 , dim.height-6);
                g.drawLine(dim.width-5, 10, dim.width-5 , dim.height-5);
                g.setColor(SystemColor.controlLtHighlight);
                g.drawLine(6, dim.height-6, dim.width-6 , dim.height-6); // 3
                g.drawLine(5, 10, dim.width-5 , 10);                     // 1
                g.drawLine(5, 10, 5 , dim.height-5);                     // 4
                g.drawLine(dim.width-6, 11, dim.width-6 , dim.height-6); // 2


        }
        g.setColor(labelColor);
        g.setFont(labelFont);
        g.drawString(label, 20, labelFont.getSize() + 5);

    }

    public static void main (String args[] ) {
         Frame f = new Frame();
         new WindowCloser(f, true);
         BorderedPanel p = new BorderedPanel("Salut", true);
         f.add(p);
         f.setSize(200, 200);
         f.setVisible(true);

    }
}



