package JaRPE;

import java.awt.*;
import java.io.*;

public class GeneralPanel extends Panel implements Serializable{

    private Color ul, dr;
    private String paneltype;

    public GeneralPanel() {
        super();
        setBackground((ul = dr = SystemColor.control));
    }

    public GeneralPanel(String paneltype) {
        super();
        setBackground((ul = dr = SystemColor.control));
        this.paneltype = paneltype;
    }

    public void setPaneltype(String paneltype) {
        this.paneltype = paneltype;
        if (getGraphics() != null) paint(getGraphics());
    }

    public String getPaneltype() {
        return this.paneltype;
    }

    public void paint(Graphics g) {
        super.paint(g);
        if (paneltype == "Inner") {
            dr = SystemColor.controlLtHighlight;
            ul = SystemColor.controlDkShadow;
        }
        if (paneltype == "Outer") {
            ul = SystemColor.controlLtHighlight;
            dr= SystemColor.controlDkShadow;
        }
        if (g != null && (paneltype == "Inner" || paneltype == "Outer"))
        synchronized(this) {
                Dimension dim = getSize();
                g.setColor(ul);
                g.drawLine(0, 0, dim.width -1, 0);
                g.drawLine(0, 0, 0, dim.height-2);
                g.setColor(dr);
                g.drawLine(dim.width-1, 1, dim.width-1, dim.height-1);
                g.drawLine(0, dim.height-1, dim.width-1, dim.height-1);

       }
    }

    public static void main (String args[] ) {
         Frame f = new Frame();
         new WindowCloser(f, true);
         f.setLayout(new GridLayout(10,1));
         for(int i = 0; i <10 ;i++){
            GeneralPanel p = new GeneralPanel("Outer");
            f.add(p);
         }
         f.setSize(200, 200);
         f.setVisible(true);

    }
}



