package JaRPE.JaRPEdit;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import JaRPE.*;

public class CompPanel extends Canvas implements Serializable, MouseListener{

    private Image img;
    private String label;
    private Color ul, dr;

    public CompPanel(Image img, String label) {
        super();
        this.img   = img;
        this.label = label;
        addMouseListener(this);
        setBounds(0,0,80,20);
        setBackground((ul = dr = SystemColor.control));
    }
    public void paint(Graphics g) {
        super.paint(g);
        Dimension dim = getSize();
        g.setColor(ul);
        g.drawLine(0, 0, dim.width -1, 0);
        g.drawLine(0, 0, 0, dim.height-2);
        g.setColor(dr);
        g.drawLine(dim.width-1, 1, dim.width-1, dim.height-1);
        g.drawLine(0, dim.height-1, dim.width-1, dim.height-1);
        if (g != null) synchronized(this) {
    	    g.setColor(Color.black);
    	    g.drawString(label, 20, 15);
    	    if (img != null) {
    	        boolean status =
    		    g.drawImage(img, 2, 2, 16, 16, this);
    		}
       }
    }

    public void mouseEntered(MouseEvent e) {
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
            paint(getGraphics());
    }
    public void mouseExited(MouseEvent e) {
            ul= getBackground();
            dr= getBackground();
            paint(getGraphics());
    }
    public void mouseClicked(MouseEvent e) {};

    public void mousePressed(MouseEvent e) {
            dr = SystemColor.controlLtHighlight;
            ul = SystemColor.controlDkShadow;
            paint(getGraphics());
    };
    public void mouseReleased(MouseEvent e) {
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
            paint(getGraphics());
            ((ComponentBoxPanel)getParent()).notifyAddComponent(label);
    };

}



