
package JaRPE.JaRPEdit;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.File;
import java.beans.*;
import JaRPE.*;

public class JaRPEdit extends Frame implements ActionListener, ItemListener, Runnable {

    private static String tmpDir = "tmp";
    private static Thread focusThread;
    private static Component nextFocus;
    private static JaRPEdit instance;
    private static String clipDir = "tmp";
    private static String clipFile = "beanBoxClip.ser";
    private static String clipResource = "beanBoxClip";
    private static String versionID = "JaRPEdit ver. 1.00, May 98, Remus Pereni";
    private static String clipLabel;
    private        String saveFileName;
    private        String savePathFileName;
    private  GeneralPanel accsuport = new GeneralPanel("Outer");
    private  WorkFrame workframe;
    private static ComponentBox componentbox;
    private        CheckboxMenuItem ckmi;
    protected Object bean;
    TrickyButton tc_new, tc_load, tc_save, tc_run, tc_help;


    public static void main (String args[]) {
        new JaRPEdit();
    }


    public JaRPEdit() {
        super ("Java Remote Process Interface Editor");
	    // Momentan este permisa numai o instanta a acestei clase.
    	if (instance != null) {
    	    throw new Error("Attempt to create multiple instances of JaRPEdit");
    	}
    	instance = this;
        setLayout(new GridLayout(1,1));
        setBackground(SystemColor.control);
      	setFont(new Font("Helvetica", Font.PLAIN, 12));
      	setIconImage(getToolkit().getImage("images/jarpe32.gif"));
        Menu m = new Menu("File");
        m.setFont(new Font("Helvetica", Font.PLAIN, 12));
        // New
        MenuItem mi = new MenuItem("New");
                 mi.addActionListener(this);
	    m.add(mi);
	    m.addSeparator();

        // Save
        mi = new MenuItem("Save");
        mi.addActionListener(this);
	    m.add(mi);

        // Save As
        mi = new MenuItem("Save As");
        mi.addActionListener(this);
	    m.add(mi);
	    m.addSeparator();

        // Load
        mi = new MenuItem("Load");
        mi.addActionListener(this);
	    m.add(mi);

        // Load New Component
        mi = new MenuItem("Load New Component");
        mi.addActionListener(this);
	    m.add(mi);
	    m.addSeparator();

        // Exit
        mi = new MenuItem("Exit");
        mi.addActionListener(this);
	    m.add(mi);

	    MenuBar mb = new MenuBar();
	    mb.add(m);
	    m = new Menu("Edit");
        m.setFont(new Font("Helvetica", Font.PLAIN, 12));

	    ckmi =new CheckboxMenuItem("GUI Builder", true);
	    ckmi.addItemListener(this);
	    m.add(ckmi);
	    m.addSeparator();
        // Cut
        mi = new MenuItem("Cut");
        mi.addActionListener(this);
	    m.add(mi);
        // Copy
        mi = new MenuItem("Copy");
        mi.addActionListener(this);
	    m.add(mi);
        // Paste
        mi = new MenuItem("Paste");
        mi.addActionListener(this);
	    m.add(mi);
        mb.add(m);
        m = new Menu("Help");
        m.setFont(new Font("Helvetica", Font.PLAIN, 12));
        // About
        mi = new MenuItem("About");
        mi.addActionListener(this);
	    m.add(mi);
	    mb.add(m);
        setMenuBar(mb);
        setLayout(new BorderLayout(0, 0));
        add("North", new GeneralLine());
        Panel bp1, bp2, bp3, bp;
        bp = new Panel(new GridLayout(1,1));

        bp1 = new Panel(new FlowLayout(FlowLayout.LEFT));
        bp2 = new Panel(new FlowLayout(FlowLayout.CENTER));
        bp3 = new Panel(new FlowLayout(FlowLayout.RIGHT));

        tc_new= new TrickyButton("New", 32,32,"images/new24.gif","images/new24g.gif", true);
        tc_new.addActionListener(this);
        tc_load= new TrickyButton("Load", 32,32,"images/file-open24.gif","images/file-open24g.gif", true);
        tc_load.addActionListener(this);
        tc_save= new TrickyButton("Save", 32,32,"images/file-save24.gif","images/file-save24g.gif", true);
        tc_save.addActionListener(this);
        bp1.add(tc_new);
        bp1.add(tc_load);
        bp1.add(tc_save);
        tc_run = new TrickyButton("Run", 32,32,"images/start24.gif","images/start24g.gif", true);
        tc_run.addActionListener(this);
        tc_help= new TrickyButton("Help",32,32,"images/help24.gif","images/help24g.gif", true);
        tc_help.addActionListener(this);
        bp1.add(tc_run);
        bp3.add(tc_help);

        bp.add(bp1);
        bp.add(bp2);
        bp.add(bp3);
        add("Center", bp);
        setSize(640, 70);
        setVisible(true);
        new WindowCloser(this, true);

    	componentbox = new ComponentBox(this, 0, 90);
	    new WindowCloser(componentbox, true);



    }

    public WorkFrame getWorkFrame() {
        return this.workframe;
    }

    public void setWorkFrame(WorkFrame workframe) {
        this.workframe = workframe;
    }

    protected void saveInterface(String type) {
        if (workframe == null) {
            new Message (this, "Error", "Nothing to Save");
            return;
        }
        if (savePathFileName == null || type == "Save As") {
            FileDialog fd = new FileDialog( this
                                           ,"Save Interface As"
                                           , FileDialog.SAVE);
            fd.setFile(saveFileName);
            fd.setDirectory(".");
            fd.show();
            if ((saveFileName = fd.getFile()) == null) return;
            savePathFileName = fd.getDirectory() + fd.getFile();
        }

        Vector vect = new Vector();
        JavinstWrapper jwr;
        Component [] cop = workframe.getComponents();

        jwr = new JavinstWrapper(workframe.getSmartPanelProp().getSmartProp(), "SmartProp");
        vect.addElement(jwr);

        for (int i = 0; i < cop.length; i++) {
            if (cop[i] instanceof Wrapper) {
                ((Wrapper)cop[i]).prepareSaveBean();
                jwr = new JavinstWrapper(((Wrapper)cop[i]).getBean(),
                                         ((Wrapper)cop[i]).getBeanName());
                vect.addElement(jwr);
            }
        }
        (new InterfaceSaver(vect, savePathFileName)).saveInterface();
        for (int i = 0; i < cop.length; i++)
            if (cop[i] instanceof Wrapper)
                ((Wrapper)cop[i]).restoreSaveBean();

    }

    protected void loadInterface() {
        if (workframe != null) {
            new Message (this, "Error", "Close first your active interface");
            return;
        }
        FileDialog fd = new FileDialog( this
                                       ,"Load Interface"
                                       , FileDialog.LOAD);
        fd.setFile(saveFileName);
        fd.setDirectory(".");
        fd.show();
        if ((saveFileName = fd.getFile()) == null) return;
        savePathFileName = fd.getDirectory() + fd.getFile();

         Vector vect = (new InterfaceLoader(savePathFileName)).loadInterface();
         saveFileName = "";
         savePathFileName=null;
         workframe = new WorkFrame(this, 140, 90, ((SmartProp)((JavinstWrapper)vect.elementAt(0)).getJavinstObject()));
       	 Beans.setDesignTime(true);
         workframe.setActive(false);
         new WindowCloser(workframe, false);
         for (int i = 1; i < vect.size(); i++) {
            JavinstWrapper wr = (JavinstWrapper)vect.elementAt(i);
            Object o = wr.getJavinstObject();
            String c = wr.getJavinstClass();
            int x= ((Component)o).getLocation().x;
            int y= ((Component)o).getLocation().y;
            ((Component)o).setLocation(5, 5);
            workframe.doInsert( o, c, c.substring(c.lastIndexOf(".") + 1)
                               ,x
                               ,y);

         }

    }

    /**
     * This implements the "loadJar" menu item.
     * Load the contents of a JAR file
     */
    private void loadJar() {
    	FileDialog fd = new FileDialog(this, "Load from JAR File", FileDialog.LOAD);
    	fd.setDirectory(System.getProperty("user.dir"));
    	fd.show();
    	String fname = fd.getFile();
    	if (fname == null) {
    	    return;
    	}
    	String dname = fd.getDirectory();
    	File file = new File(dname, fname);

	    componentbox.addBeansInJar(file.getPath());
    }

    public void run() {
    }

    public void actionPerformed( ActionEvent ev) {
        // RUN
        if (ev.getActionCommand() == "Run") {
            ckmi.setState( !ckmi.getState());
            if (ckmi.getState()) tc_run.changeImages("images/start24.gif", "images/start24g.gif", true);
            else tc_run.changeImages("images/stop24.gif", "images/stop24g.gif", true);
            componentbox.setVisible(ckmi.getState());
            workframe.setActive(!ckmi.getState());

        }

        if (ev.getActionCommand() == "New") {
            saveFileName = "";
            savePathFileName=null;
            workframe = new WorkFrame(this, 140, 90);
          	Beans.setDesignTime(true);
          	workframe.setActive(false);
            new WindowCloser(workframe, false);
        }

        if (ev.getActionCommand() == "Save" ||
            ev.getActionCommand() == "Save As") {
            if (saveFileName == "") {           // acum se salveaza pentru prima data
                saveFileName= (getWorkFrame()).getTitle() + ".itf";
            }
            saveInterface(ev.getActionCommand());
        }
        if (ev.getActionCommand() == "Load") {
            loadInterface();
        }
        if (ev.getActionCommand() == "Load New Component") {
            loadJar();
        }
        if (ev.getActionCommand() == "Copy") {
            getWorkFrame().getCurrentBean().copy();
        }

        if (ev.getActionCommand() == "Cut") {
            getWorkFrame().getCurrentBean().cut();
        }

        if (ev.getActionCommand() == "Paste") {
            getWorkFrame().paste();
        }

        if (ev.getActionCommand() == "Exit") System.exit(0);

    }

    public void itemStateChanged(ItemEvent e) {
               if (ckmi.getState()){
                    tc_run.changeImages("images/start24.gif", "images/start24g.gif",false);
                    componentbox.setVisible(true);
               }
               else {
                    tc_run.changeImages("images/stop24.gif", "images/stop24g.gif", false);
                    componentbox.setVisible(false);
               }
               workframe.setActive(e.getStateChange() != ItemEvent.SELECTED);
    }
}