package JaRPE.Javins;

import java.awt.*;
import java.io.Serializable;


public class AlertLabel extends Label implements Serializable {

    protected String alertText          = "";
    protected Color  alertBackground    = Color.red;
    protected Color  normalBackground   = SystemColor.activeCaption;
    protected Color  textColor          = SystemColor.activeCaptionText;


    public AlertLabel() {
        super();
        setBackground(normalBackground);
        setForeground(textColor);
        setFont(new Font("Helvetica", Font.BOLD, 8));
        setAlignment(Label.CENTER);
        setText(alertText);
    }

    public void setMessage(boolean alert, String message) {

        if (alert) {
            setBackground(alertBackground);
            this.alertText= message;
            setText(message);

        }
        else {
            setBackground(normalBackground);
            this.alertText= message;
            setText(message);
        }
    }

    public String getMessage() {
        return this.alertText;
    }
}
