
package JaRPE.Javins;

import java.awt.*;
import java.awt.event.*;
import JaRPE.*;
import JaRPE.Javins.*;
import java.io.*;



public class JaviDiagram extends BaseJavins implements ItemListener, Serializable, Runnable{

    Diagram b;

    private boolean newValue = false;
    private byte    valueByte= 1;

    private   Checkbox chBox;
    protected boolean grid = true;
    Panel panel;

    public JaviDiagram() {
        super();
        setComponentName("JaviDiagram");
        b = new Diagram();
        panel = new Panel(new BorderLayout(10,10));
        chBox= new Checkbox("Grid", true);
        chBox.addItemListener(this);
        b.setBounds(0, 0, 200, 200);
        panel.add(b, BorderLayout.CENTER);
        panel.add(chBox, BorderLayout.NORTH);
        add(panel);
        b.setFont(new Font("Helvetica", Font.BOLD, 12));
        b.setGrid(true);

    }

    public void setGrid(boolean grid) {
        this.grid = grid;
        chBox.setState(grid);
        b.setGrid(grid);
    }

    public boolean isGrid() {
        return this.grid;
    }


    public void  readSignal(SignalInputStream mySignalIn) throws IOException{
        byte readValue = mySignalIn.readByte();
        if ( readValue != 0 ) {
            b.draw(readValue -1);
            valueByte = readValue;
            synchronized (this) {
                newValue = true;
            }
        }
    }

    public boolean  writeSignal(DataOutputStream myDataOut) throws IOException{
        myDataOut.writeByte(0);
        return true;
    }

    public boolean  writeSignal2Server(DataOutputStream signalOut) throws IOException{
        if (newValue) {
                signalOut.writeByte(valueByte);
                synchronized(this) {
                    newValue = false;
                }
        }
        else signalOut.writeByte(0);

        return true;
    }

    public void  readSignalFServer(DataInputStream signalIn)  throws IOException{
       int readValue;
       readValue = signalIn.readByte();
    }

    private void writeObject (ObjectOutputStream oos) throws IOException{
        oos.defaultWriteObject();
    }

    private void readObject (ObjectInputStream ois) throws IOException, ClassNotFoundException {
        ois.defaultReadObject();
        localSignalSourceClass = "";
    }


    public static void main (String args[]) {
        JaviDiagram bj = new JaviDiagram();
        Frame f = new Frame(bj.getComponentName() + " -> Test <-");
        f.setLayout(new BorderLayout());
        f.add(bj);
        f.setSize(bj.getSize().width, bj.getSize().height);
        f.pack();
        f.show();
        Thread t = new Thread(bj);
        System.runFinalizersOnExit(true);
        new WindowCloser(f, true);
        bj.setSourcePort(3002);
        bj.setSourceURL("localhost");
        bj.initializeConections();
        bj.conected = true;
        bj.run();
    }


    public void itemStateChanged(ItemEvent ev) {
        if (ev.getStateChange() == ItemEvent.SELECTED) setGrid(true);
        else setGrid(false);
    }
}
