package JaRPE.Javins;

import java.awt.*;
import java.awt.event.*;
import java.io.Serializable;
import JaRPE.*;

public class MultiPosInterface extends Canvas implements MouseListener,
                                                         MouseMotionListener,
                                                         Serializable{

    protected int    curentSelection = 0;
    protected int    numberOfSelections =4;
    protected Point  points[];
    protected int    raza;
    protected int    centrux, centruy;

    ActionListener actionListener;
    String    actionCommand;

    public MultiPosInterface(int nrofsel) {
        super() ;
        setBackground(SystemColor.control);
        setBounds(0,0,70,70);
        addMouseListener(this);
        addMouseMotionListener(this);
        this.numberOfSelections = nrofsel;
        points = new Point[numberOfSelections];

    }


    public void setCurrent(int current) {
       if (curentSelection != current) {
            this.curentSelection = current;
            repaint();
       }
    }

    public int getCurrent() {
        return this.curentSelection ;
    }

    protected void initializePoints () {
          Dimension dim = getSize();
          raza    = (dim.width/3);
          centrux = dim.width/2;
          centruy = dim.height/2;
          for (int i = 0; i < numberOfSelections ; i++) {
             switch (i) {
                case 0 :
                        points[0] = new Point(centrux-4, centruy-raza-10);
                        break;

                case 1 :
                        points[1] = new Point(centrux-4, centruy+raza +2);
                        break;
                case 2 :
                        points[2] = new Point(centrux+raza+2, centruy-4);
                        break;
                case 3 :
                        points[3] = new Point(centrux-raza-10, centruy-4);
                        break;
             }
        }


    }

    protected int getUnghi() {
        switch(curentSelection) {
            case 0 : return 90 ;
            case 1 : return 270 ;
            case 2 : return 0  ;
            case 3 : return 180;
        }
       return 90;
    }

    protected int getUnghi(int xx, int yy) {
        int angle = 0;
        int xc=0,yc=0;
        if ( xx > centrux && yy > centruy) {
            angle = 270;
            xc = xx - centrux;
            yc = yy - centruy;
        } else
        if ( xx < centrux && yy > centruy) {
            angle = 180;
            yc = centrux - xx;
            xc = yy - centruy;
        } else
        if ( xx < centrux && yy < centruy) {
            angle = 90;
            xc = centrux - xx;
            yc = centruy - yy;
        } else
        if ( xx> centrux && yy < centruy) {
            yc = xx - centrux;
            xc = centruy - yy;
        }

        int unghi=0;

        try {
             unghi = (new Double((Math.atan(Math.tan(xc/yc)))* 180 /Math.PI)).intValue();
            if (unghi < 0) unghi = unghi * (-1);
        } catch (Exception e) {}
        return (unghi + angle);
    }



    public void putPoint(int unghi, Graphics g) {
        Dimension dim = getSize();
        double fi   =  unghi* Math.PI/180;
        double xdep =  raza * Math.cos(fi);
        double ydep =  raza * Math.sin(fi);
        Point pp = new Point();
        if (unghi < 90) {
            pp = new Point ((new Double(centrux + xdep - 9)).intValue(),
                            (new Double(centruy - ydep - 3)).intValue());
        } else
        if (unghi >=90 && unghi < 180) {
            pp = new Point ((new Double(centrux + xdep - 3)).intValue(),
                            (new Double(centruy - ydep + 3)).intValue());
        }else
        if (unghi >=180 && unghi < 270){
            pp = new Point ((new Double(centrux + xdep + 3)).intValue(),
                             (new Double(centruy- ydep - 3)).intValue());
        }else
        if (unghi >=270 && unghi < 359){
            pp = new Point ((new Double(centrux + xdep - 3 )).intValue(),
                            (new Double(centruy - ydep - 9 )).intValue());
        }
        g.setColor(Color.green);
        g.fillArc(pp.x, pp.y, 6, 6, 90, 360);
    }

    public void paint(Graphics g) {
       if (g != null) {
            initializePoints();
            Dimension dim = getSize();
            g.clearRect(0, 0, dim.width, dim.height);
            g.setColor(SystemColor.controlLtHighlight);
            g.drawArc(centrux-raza, centruy - raza, 2*raza, 2*raza, 45, 180);
            g.setColor(SystemColor.controlShadow);
            g.drawArc(centrux-raza, centruy - raza, 2*raza, 2*raza, 225, 180);
            for (int i = 0; i < numberOfSelections; i++)
                    draw3D(points[i].x, points[i].y, 8, 8, (i == curentSelection), g);
            putPoint(getUnghi(), g);
       }

    }


    protected void draw3D(int x, int y, int width, int height, boolean marked, Graphics g) {
            g.setColor(SystemColor.controlShadow);
            g.drawLine(x + width, y, x + width, y+height);
            g.drawLine(x, y + height, x + width, y + height);
            g.setColor(SystemColor.controlLtHighlight);
            g.drawLine(x, y, x + width, y);
            g.drawLine(x, y, x, y + height);
            if (marked) {
                    g.setColor(Color.red);
                    g.fillRect(x + 2, y + 2, width - 2, height - 2);
            }

    }


    public void mouseClicked (MouseEvent me) {;}

    public void mouseEntered (MouseEvent me) {;}

    public void mouseExited  (MouseEvent me) {;}

    public void mousePressed (MouseEvent me) {
        int unghi =getUnghi(me.getX(), me.getY());
        putPoint(unghi, getGraphics());;
        repaint();
    }

    public void mouseReleased(MouseEvent me) {
        int x = me.getX();
        int y = me.getY();
        for (int i = 0; i < numberOfSelections; i++) {
            if (x >= points[i].x && x <= points[i].x + 10 &&
                y >= points[i].y && y <= points[i].y + 10) {
                setActionCommand( "" + i);
                curentSelection = i;
                paint(getGraphics());
                ActionEvent ae = new ActionEvent(this, 1, getActionCommand());
                processActionEvent(ae);
            }
        }

    }

    public void mouseDragged(MouseEvent me) {
        int unghi =getUnghi(me.getX(), me.getY());
        putPoint(unghi, getGraphics());
        repaint();
    }

    public void mouseMoved(MouseEvent me) {;}

    public void setActionCommand(String command) {
        actionCommand = command;
    }

    public String getActionCommand() {
        return actionCommand;
    }

    public synchronized void addActionListener(ActionListener l) {
    	actionListener = AWTEventMulticaster.add(actionListener, l);
    }

    public synchronized void removeActionListener(ActionListener l) {
	actionListener = AWTEventMulticaster.remove(actionListener, l);
    }

    protected void processEvent(AWTEvent e) {
        if (e instanceof ActionEvent) {
            processActionEvent((ActionEvent)e);
            return;
        }
	super.processEvent(e);
    }

    protected void processActionEvent(ActionEvent e) {
        if (actionListener != null) {
            actionListener.actionPerformed(e);
        }
    }

    protected String paramString() {
	    return super.paramString();
    }

}


