/**********************************************************************************
 * ClassName  :   RemoteSignalSource
 * Date       :   17, Mai  1998
 * Autor      :   Remus Pereni [RP]
 * Description:   Vezi mai jos
 **********************************************************************************/

package JaRPE.Javins;


/**
* RemoteSignalSource - implementeaza o interfata comuna pentru toate
* Javinsurile care pot prelua un semnal de la un server de semnal
* prin internet sau intranet
*
* @author   Remus Pereni
* @version  0.01, 17 May 1998 01:30 AM
*/

public interface RemoteSignalSource {

    String sourceURL =""  ;
    int    sourcePort=3000;

    /** Seteaza URL-ul la care se va conecta in vedera comunicatie,
    * cu obiectul oglinda, generator de semnal
    * @param sourceURL - URL-ul
    */
    public void   setSourceURL(String sourceURL);

    /** Returneaza URL-ul la care se va conecta in vedera comunicatie, cu
    *    obiectul oglinda, generator de semnal
    * @return  - URL-ul
    */
    public String getSourceURL();

    /** Seteaza portul la care se va conecta in vedera comunicatie,
    * cu obiectul oglinda, generator de semnal
    * @param sourcePort - portul
    */
    public void setSourcePort(int sourcePort);

    /** Returneaza portul la care se va conecta in vedera comunicatie, cu
    *    obiectul oglinda, generator de semnal
    * @return  - portul
    */
    public int  getSourcePort();


    /** Incearca conectarea la sursa de semnal, situata remote, prin
    * intreemediul internetului sau a intranetului
    *
    */
    public void connectRemoteSignalSource();

    /**
    * Se culege perechea de streamuri de data (DataInputStream,
    * DataOutputStream), pentru comunicatia bidirectionala
    *   @return SignalPair - Cele doua streamuri (In/Out de date)
    */
    public SignalPair getRemoteSignalPair();

}

