package JaRPE;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import JaRPE.*;

public class TrickyCanvas extends Canvas implements Serializable, MouseListener{
    private Color ul, dr;
    private Image   img;
    private Image   colorimg;
    private Image   monoimg;
    private int     width;
    private int     height;
    private boolean doubleimg;
    private boolean upeffect;
    private String  imgLocation;
    private String  command;

    public TrickyCanvas(String command) {
        super();
        this.command = command;
        addMouseListener(this);
        setBackground((ul = dr = SystemColor.control));
    }

    public TrickyCanvas(String command, int width, int height, String imgLocation) {
        super();
	    this.width 	= width;
    	this.height	= height;
        this.imgLocation= imgLocation;
        this.command = command;
        addMouseListener(this);
	    setBounds(0, 0, width, height);
        setSize(width, height);
    	colorimg =(getToolkit()).getImage(imgLocation);
    	img = colorimg;
        setBackground((ul = dr = SystemColor.control));
    }
    public TrickyCanvas(String command, int width, int height, String cimgLocation, String mimgLocation, boolean upeffect) {
        super();
    	this.width 	= width;
    	this.height	= height;
        this.imgLocation= imgLocation;
    	this.doubleimg	= true;
    	this.upeffect   = upeffect;
        this.command = command;
        addMouseListener(this);
    	setBounds(0, 0, width, height);
        setSize(width, height);
    	colorimg =(getToolkit()).getImage(cimgLocation);
    	monoimg  =(getToolkit()).getImage(mimgLocation);
    	img = monoimg;
        setBackground((ul = dr = SystemColor.control));
    }


    public void paint(Graphics g){
	   if (g != null) synchronized(this) {
                Dimension dim = getSize();
                g.setColor(ul);
                g.drawLine(0, 0, dim.width -1, 0);
                g.drawLine(0, 0, 0, dim.height-2);
                g.setColor(dr);
                g.drawLine(dim.width-1, 1, dim.width-1, dim.height-1);
                g.drawLine(0, dim.height-1, dim.width-1, dim.height-1);
		if ( img != null )
			g.drawImage(img, 4, 4, dim.width-8, dim.height-8, this);
	    }
    }

    public void mouseEntered(MouseEvent e) {
	if(upeffect){
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
	}
	if (doubleimg) img= colorimg;
        paint(getGraphics());
    }
    public void mouseExited(MouseEvent e) {
    	    ul= getBackground();
            dr= getBackground();
	if (doubleimg) img= monoimg;
        paint(getGraphics());
    }
    public void mouseClicked(MouseEvent e) {};

    public void mousePressed(MouseEvent e) {
            dr = SystemColor.controlLtHighlight;
            ul = SystemColor.controlDkShadow;
            paint(getGraphics());
    };
    public void mouseReleased(MouseEvent e) {
          if(upeffect){
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
	  }else {
            ul= getBackground();
            dr= getBackground();
	  }
          paint(getGraphics());
          ActionEvent ne = new ActionEvent(this, 1, command);
          dispatchEvent(ne);
    };

    public static void main (String args[] ) {
         Frame f = new Frame();
         new WindowCloser(f, true);
         f.setLayout(new FlowLayout());
	 f.setBackground(SystemColor.control);
         f.add( new TrickyCanvas("test", 32,32,"images/new24.gif","images/new24g.gif", true));
         f.add( new TrickyCanvas("test1", 32,32,"images/file-open24.gif","images/file-open24g.gif", true));

         f.setSize(200, 60);
         f.setVisible(true);

    }
}

