package JaRPE;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class TrickyLine extends Canvas implements Serializable, MouseListener{

    private Color ul, dr;

    public TrickyLine() {
        super();
        addMouseListener(this);
        setBackground((ul = dr = SystemColor.control));
    }
    public void paint(Graphics g) {
        super.paint(g);
        if (g != null) synchronized(this) {
                Dimension dim = getSize();
                g.setColor(ul);
                g.drawLine(0, 0, dim.width -1, 0);
                g.drawLine(0, 0, 0, dim.height-2);
                g.setColor(dr);
                g.drawLine(dim.width-1, 1, dim.width-1, dim.height-1);
                g.drawLine(0, dim.height-1, dim.width-1, dim.height-1);

       }
    }
    public void mouseEntered(MouseEvent e) {
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
            paint(getGraphics());
    }
    public void mouseExited(MouseEvent e) {
            ul= getBackground();
            dr= getBackground();
            paint(getGraphics());
    }
    public void mouseClicked(MouseEvent e) {};

    public void mousePressed(MouseEvent e) {
            dr = SystemColor.controlLtHighlight;
            ul = SystemColor.controlDkShadow;
            paint(getGraphics());
    };
    public void mouseReleased(MouseEvent e) {
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
            paint(getGraphics());
    };

    public static void main (String args[] ) {
         Frame f = new Frame();
         new WindowCloser(f, true);
         f.setLayout(new GridLayout(10,1));
         for(int i = 0; i <10 ;i++){
            TrickyPanel p = new TrickyPanel();
            f.add(p);
         }
         f.setSize(200, 200);
         f.setVisible(true);

    }
}



