import java.lang.Math;
import java.io.*;
import java.lang.Thread;
import JaRPE.*;
import JaRPE.Javins.*;


public class Generator implements Runnable, LocalSignalSource {

    private int type= 3 ; // 1 -triunghi
                          // 2 -dreptunghi
                          // 3 -sinusoidal

    private int amplit= 20, perio= 20;
    private int cnt;
    private boolean desc;
    public  PipedOutputStream pop;
    public  PipedInputStream  pip;

    public  SignalPair sigpa;
    public  LocalSignalSource localSignalSource;
    public  String localSignalSourceClass;

    private Thread t;

    public Generator() {
        try {
            sigpa = new SignalPair();
            localSignalSource = this;
            pop= new PipedOutputStream();
            pip= new PipedInputStream(pop);
            DataInputStream dis= new DataInputStream(pip);
            sigpa.signalIn  = dis;
            sigpa.signalOut = null;
        }catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    public void setLocalSignalSourceClass (String localSignalSourceClass) {
        this.localSignalSourceClass = localSignalSourceClass;
    }

    public String getLocalSignalSourceClass () {
        return this.localSignalSourceClass;
    }

    public LocalSignalSource getLocalSignalSourceInstance () {
        String className = getLocalSignalSourceClass();
        if (className != "" && className != null && localSignalSource == null) {
            try {
                  Class localSignalSClass = Class.forName(className);

                  LocalSignalSource lss = (LocalSignalSource)
                                           localSignalSClass.newInstance();
                  setLocalSignalSource(lss);
                  return lss;
            } catch (ClassNotFoundException ex) {
                    System.err.println("Problems in :"           +
                                       this.getClass().getName() +
                                       " at getLocalSignalSource -> " +
                                       className  + " not found !");
                    ex.printStackTrace();
                    System.err.println("LocalSignalSource initializet to -> NULL <-  !");
                    return null;
            }
              catch (Exception ex) {
                    System.err.println("Problems in :"           +
                                       this.getClass().getName() +
                                       " at getLocalSignalSource -> " +
                                       className  + " can not be initialized !");
                    ex.printStackTrace();
                    System.err.println("LocalSignalSource initializet to -> NULL <-  !");
                    return null;
              }
        }
        else return null;
    }

    public void setLocalSignalSource ( LocalSignalSource localSignalSource) {
        this.localSignalSource = localSignalSource;
    }

    public LocalSignalSource getLocalSignalSource () {
        if (localSignalSource == null)
        return null;
        else return this.localSignalSource;
    }

    public SignalPair getLocalSignalPair () {
        return sigpa;

    }


    public int getNextValue() {
        switch (type) {
            case 1: if (cnt > amplit) desc = true;
                    if (cnt < amplit*-1) desc= false;
                    if (desc) cnt--;
                    else cnt++;
                   break;
            case 2: cnt++;
                    if (cnt > perio) cnt = 0 ;
                    if (cnt == 0)       return 0;
                    if (cnt < perio/2 && cnt != 0) return amplit;
                    if (cnt == perio/2 )            return 0;
                    if (cnt > perio/2 && cnt < perio) return amplit*-1;
                    if (cnt == perio)   { cnt = 0; return 0; }

                   break;
            case 3: ++cnt;
                    return ((new Double(Math.sin(cnt*Math.PI/70)* amplit)).intValue());


        }
        return cnt;
    }

    public void run() {
       t= Thread.currentThread();
       try{
        while(true) {
        int i = getNextValue();
        pop.write(i);
        pop.flush();
        t.sleep(5);
        t.yield();
        }
       }catch(Exception e) {System.out.println(e.toString());}
    }

    public void setAmplitude(int amplit) {
        this.amplit = amplit;
    }

    public void setPeriode(int perio ) {
        this.perio = perio;
    }

    public void setSignal(int type, int amplit, int perio) {
        this.type   = type;
        this.amplit = amplit;
        this.perio  = perio;
        cnt = 0;
    }
}
