
import java.awt.*;
import java.awt.event.*;
import java.lang.Thread;
import java.io.*;
import java.net.*;
import JaRPE.*;
import JaRPE.Javins.*;

public class SignalGen extends Frame implements MouseListener, ActionListener {

    public Panel upppanel, midpanel, dowpanel, midleft, midright;

    public Generator    generator;
    public JaviButton   javiButton;
    public JaviMultiPos javiMultiPos;
    public JaviDiagram  javiDiagram;

    public Thread javiButtonThread;
    public Thread javiMultiPosThread;
    public Thread generatorThread;
    public Thread javiDiagramThread;



    public SignalGen () {
        super("Signal Generator Simulator");
        setLayout(new BorderLayout(20,20));
        setBackground(SystemColor.control);
        setFont(new Font("Helvetica", Font.PLAIN, 12));
        upppanel = new Panel(new FlowLayout(FlowLayout.RIGHT));
        midpanel = new Panel(new BorderLayout(20,20));
        dowpanel = new Panel(new FlowLayout(FlowLayout.CENTER));

        midright  = new Panel(new BorderLayout());
        javiMultiPos = new JaviMultiPos();
        javiMultiPos.setLabelItems("Sinus.,Triun.,Drept.");
        midright.add(javiMultiPos, BorderLayout.SOUTH);

        javiButton = new JaviButton();
        upppanel.add(javiButton);
        javiDiagram = new JaviDiagram();
        midpanel.add(midright, BorderLayout.EAST);
        midpanel.add(javiDiagram, BorderLayout.CENTER);

        add(upppanel, BorderLayout.NORTH);
        add(midpanel, BorderLayout.CENTER);
        add(dowpanel, BorderLayout.SOUTH);
        pack();
        setBounds(0, 0, 640, 480);
        setVisible(true);


   // JaviButton
        javiButtonThread = new Thread(javiButton);
        javiButton.addActionListener(this);
        javiButton.setServerPort(3000);
        javiButton.setServer(true);
        javiButton.setLocalSignalSource(javiButton);
        javiButton.initializeConections();
        javiButton.setConected(true);
        javiButtonThread.start();

   // JaviMultiPos
        javiMultiPosThread = new Thread(javiMultiPos);
        javiMultiPos.addActionListener(this);
        javiMultiPos.setServerPort(3001);
        javiMultiPos.setServer(true);
        javiMultiPos.setLocalSignalSource(javiMultiPos);
        javiMultiPos.initializeConections();
        javiMultiPos.setConected(true);
        javiMultiPosThread.start();

        // Generator
        generator = new Generator();
        generatorThread = new Thread(generator);
        generatorThread.start();

        // JaviDiagram
        javiDiagramThread= new Thread(javiDiagram);
        javiDiagram.setLocalSignalSource(generator);
	javiDiagram.setServerPort(3002);
        javiDiagram.setServer(true);
        javiDiagram.initializeConections();
        javiDiagram.setConected(true);
        javiDiagramThread.start();

    }


    public static void main (String args[]) {
        System.runFinalizersOnExit(true);
        SignalGen sg = new SignalGen();
        new WindowCloser(sg, true);
    }

    public void mouseClicked (MouseEvent me) {;}

    public void mouseEntered (MouseEvent me) {;}

    public void mouseExited  (MouseEvent me) {;}

    public void mousePressed (MouseEvent me) {;}

    public void mouseReleased(MouseEvent me) {;}

    public void mouseDragged (MouseEvent me) {;}

    public void mouseMoved   (MouseEvent me) {;}

    public void actionPerformed(ActionEvent e) {
       if (e.getSource() instanceof JaviButton)
           if (e.getActionCommand() == "OFF") {
            try{
                System.out.println("Distroying threads");
                javiMultiPos.closeConections();
                javiDiagram.closeConections();
                javiButton.closeConections();

                javiMultiPosThread.stop();
                javiDiagramThread.stop();
                generatorThread.stop();
                dispose();
                System.exit(0);
            }catch (Exception ex) {
              System.err.println("Threads can not be stoped");
              System.exit(0);
            }
           }

           if (e.getActionCommand().equals("0")) generator.setSignal(3, 20, 20);
           if (e.getActionCommand().equals("1")) generator.setSignal(1, 20, 20);
           if (e.getActionCommand().equals("2")) generator.setSignal(2, 20, 20);
    }
}
