package JaRPE;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class TrickyButton extends Canvas implements Serializable, MouseListener{
    private Color ul, dr;
    private Image   img;
    private Image   colorimg;
    private Image   monoimg;
    private int     width;
    private int     height;
    private boolean doubleimg;
    private boolean upeffect;
    private String  imgLocation;
    String actionCommand;

   transient ActionListener actionListener;


    public TrickyButton(String command) {
        super();
        setActionCommand(command);
        addMouseListener(this);
        setBackground((ul = dr = SystemColor.control));
    }

    public TrickyButton(String command, int width, int height, String imgLocation) {
        super();
	    this.width 	= width;
    	this.height	= height;
        this.imgLocation= imgLocation;
        setActionCommand(command);
        addMouseListener(this);
	    setBounds(0, 0, width, height);
        setSize(width, height);
    	colorimg =(getToolkit()).getImage(imgLocation);
    	img = colorimg;
        setBackground((ul = dr = SystemColor.control));
    }

    public TrickyButton(String command, int width, int height, Image img) {
        super();
	    this.width 	 = width;
    	this.height	 = height;
    	this.upeffect= true;
        setActionCommand(command);
        addMouseListener(this);
	    setBounds(0, 0, width, height);
        setSize(width, height);
    	colorimg = this.img = img;
        setBackground((ul = dr = SystemColor.control));
    }

    public TrickyButton(String command, int width, int height, String cimgLocation, String mimgLocation, boolean upeffect) {
        super();
    	this.width 	= width;
    	this.height	= height;
        this.imgLocation= imgLocation;
    	this.doubleimg	= true;
    	this.upeffect   = upeffect;
        setActionCommand(command);
        addMouseListener(this);
        enableEvents(AWTEvent.ACTION_EVENT_MASK);
    	setBounds(0, 0, width, height);
    	colorimg =(getToolkit()).getImage(cimgLocation);
    	monoimg  =(getToolkit()).getImage(mimgLocation);
    	img = monoimg;
        setBackground((ul = dr = SystemColor.control));
    }

    public synchronized void addActionListener(ActionListener l) {
    	actionListener = AWTEventMulticaster.add(actionListener, l);
    }

    public synchronized void removeActionListener(ActionListener l) {
	actionListener = AWTEventMulticaster.remove(actionListener, l);
    }

    protected void processEvent(AWTEvent e) {
        if (e instanceof ActionEvent) {
            processActionEvent((ActionEvent)e);
            return;
        }
	super.processEvent(e);
    }

    protected void processActionEvent(ActionEvent e) {
        if (actionListener != null) {
            actionListener.actionPerformed(e);
        }
    }

    public void setActionCommand(String command) {
        actionCommand = command;
    }

    public String getActionCommand() {
        return actionCommand;
    }

    protected String paramString() {
	    return super.paramString();
    }

    public void changeImages(String imgSource1, String imgSource2, boolean active) {
    	colorimg =(getToolkit()).getImage(imgSource1);
    	monoimg  =(getToolkit()).getImage(imgSource2);
        if (active)	img = colorimg;
        else img = monoimg;
        paint(getGraphics());
    }

    public void paint(Graphics g){
	   if (g != null) synchronized(this) {
                Dimension dim = new Dimension(width, height);
                g.setColor(ul);
                g.drawLine(0, 0, dim.width -1, 0);
                g.drawLine(0, 0, 0, dim.height-2);
                g.setColor(dr);
                g.drawLine(dim.width-1, 1, dim.width-1, dim.height-1);
                g.drawLine(0, dim.height-1, dim.width-1, dim.height-1);
		if ( img != null )
			g.drawImage(img, 4, 4, dim.width-8, dim.height-8, this);
	    }
    }

    public void mouseEntered(MouseEvent e) {
	if(upeffect){
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
	}
	if (doubleimg) img= colorimg;
        paint(getGraphics());
    }
    public void mouseExited(MouseEvent e) {
    	    ul= getBackground();
            dr= getBackground();
	if (doubleimg) img= monoimg;
        paint(getGraphics());
    }
    public void mouseClicked(MouseEvent e) {};

    public void mousePressed(MouseEvent e) {
            dr = SystemColor.controlLtHighlight;
            ul = SystemColor.controlDkShadow;
            paint(getGraphics());
    };

    public void mouseReleased(MouseEvent e) {
          if(upeffect){
            ul = SystemColor.controlLtHighlight;
            dr = SystemColor.controlDkShadow;
	  }else {
            ul= getBackground();
            dr= getBackground();
	  }
          paint(getGraphics());
          ActionEvent ne = new ActionEvent(this, 1, getActionCommand());
          processActionEvent(ne);
    };

    public static void main (String args[] ) {
         Frame f = new Frame();
         new WindowCloser(f, true);
         f.setLayout(new FlowLayout());
	     f.setBackground(SystemColor.control);
         f.add( new TrickyButton("test", 32,32,"images/new24.gif","images/new24g.gif", true));
         f.add( new TrickyButton("test1", 32,32,"images/file-open24.gif","images/file-open24g.gif", true));

         f.setSize(200, 60);
         f.setVisible(true);

    }
}

